"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.materialize = void 0;

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _get = _interopRequireDefault(require("lodash/get"));

var _utils = require("../utils");

var _filters = require("../filters");

var _dynamodb = require("../utils/dynamodb");

const materialize = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(_filters.outSkip).filter(_filters.outSourceIsSelf).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).through(split(rule)).map(toUpdateRequest(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through((0, _dynamodb.updateDynamoDB)(rule)).tap(_utils.printEndPipeline);

exports.materialize = materialize;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toUpdateRequest = rule => (0, _utils.faultyAsyncStream)(async uow => ({ ...uow,
  updateRequest: await (0, _utils.faultify)(rule.toUpdateRequest)(uow, rule)
}));

const split = ({
  splitOn,
  splitTargetField = 'split',
  ...rule
}) => {
  if (splitOn) {
    if ((0, _isFunction.default)(splitOn)) {
      return s => s.flatMap((0, _utils.faulty)(uow => splitOn(uow, rule)));
    } else {
      return s => s.flatMap((0, _utils.faulty)(uow => {
        const values = (0, _get.default)(uow.event, splitOn);
        return values.map(v => ({ ...uow,
          [splitTargetField]: v
        }));
      }));
    }
  } else {
    return s => s;
  }
};